<!-- 测试、校准或检定合格分包方名录列表 -->
<script lang="ts" setup name="SubpakageReviewList">
import { reactive, ref } from 'vue'
import { ElLoading, ElMessage, ElMessageBox } from 'element-plus'
import ApprovalDialog from './ApprovalDialog.vue'
import { cancelReview, deleteReview, exportReview, getListPage, submitReview } from '@/api/eqpt/subpackage/review'
import { SCHEDULE } from '@/utils/scheduleDict'
import { exportFile } from '@/utils/exportUtils'
const $props = defineProps({
  statusName: {
    type: String,
    default: '',
  },
})
const applyDict = ref<{ [key: string]: string }>({
  审批: '',
  草稿箱: '1',
  审批中: '3',
  已通过: '4',
  未通过: '5',
  已取消: '6',
})
const { proxy } = getCurrentInstance() as any
const listQuery = reactive({
  createTimeEnd: '',
  createTimeStart: '',
  createUserName: '',
  reviewNo: '',
  subcontractorCompanyName: '',
  offset: 1,
  limit: 20,
  approvalStatus: '',
  formId: SCHEDULE.SUBCONTRACT_REVIEW_APPROVAL,
})
const columns = ref([
  {
    text: '评审表编号',
    value: 'reviewNo',
    align: 'center',
  },
  {
    text: '评审表名称',
    value: 'reviewName',
    align: 'center',
  },
  {
    text: '分包机构名称',
    value: 'subcontractorCompanyName',
    align: 'center',
  },
  {
    text: '机构负责人',
    value: 'subcontractorDirectorName',
    align: 'center',
  },
  {
    text: '申请人',
    value: 'createUserName',
    align: 'center',
  },
  {
    text: '申请时间',
    value: 'createTime',
    align: 'center',
  },
])
const list = ref([])
const total = ref(0)
const listLoading = ref(true)

// 获取列表数据
const fetchData = (isNowPage = true) => {
  list.value = []
  total.value = 0
  listLoading.value = true
  if (!isNowPage) {
    // 是否显示当前页，否则跳转第一页
    listQuery.offset = 1
  }
  getListPage(listQuery, $props.statusName).then((response) => {
    list.value = response.data.rows
    total.value = parseInt(response.data.total)
    listLoading.value = false
  }).catch(() => {
    listLoading.value = false
  })
}
// 查询数据
const search = () => {
  fetchData(false)
}
// 开始结束时间
const datetimerange = ref()
watch(() => datetimerange.value, (newVal) => {
  listQuery.createTimeStart = ''
  listQuery.createTimeEnd = ''
  if (Array.isArray(newVal)) {
    if (newVal.length) {
      listQuery.createTimeStart = `${newVal[0]} 00:00:00`
      listQuery.createTimeEnd = `${newVal[1]} 23:59:59`
    }
  }
})
// 重置
const reset = () => {
  datetimerange.value = []
  listQuery.createTimeEnd = ''
  listQuery.createTimeStart = ''
  listQuery.createUserName = ''
  listQuery.reviewNo = ''
  listQuery.subcontractorCompanyName = ''
  listQuery.offset = 1
  listQuery.limit = 20
  search()
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size: number; page: number }) => {
  if (val && val.size) {
    listQuery.limit = val.size
  }
  if (val && val.page) {
    listQuery.offset = val.page
  }
  fetchData()
}
// 表格被选中的行
const selectList = ref<any[]>([])
// 表格多选
const multiSelect = (row: any[]) => {
  selectList.value = row
}
const $router = useRouter()
// 新建编辑操作
const handler = (row: any, type: string) => {
  $router.push({
    path: `/reviewpage/${type}`,
    query: {
      row: JSON.stringify(row),
      id: row.id,
      statusName: $props.statusName,
    },
  })
}
// 详情
const detail = (row: any) => {
  if ($props.statusName === '草稿箱' || $props.statusName === '未通过' || $props.statusName === '已取消') {
    handler(row, 'update')
  }
  else {
    $router.push({
      path: `/reviewpage/${'detail'}`,
      query: {
        row: JSON.stringify(row),
        id: row.id,
        statusName: $props.statusName,
      },
    })
  }
}
// 删除
const delHandler = (row: any) => {
  ElMessageBox.confirm(
    '确认删除吗?',
    '确认',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  ).then(() => {
    deleteReview({ id: row.id }).then((res) => {
      ElMessage.success('操作成功')
      search()
    })
  })
}
// 导出列表
const exportList = () => {
  if (list.value.length) {
    const loading = ElLoading.service({
      lock: true,
      text: 'Loading',
      background: 'rgba(255, 255, 255, 0.8)',
    })
    const data = {
      ...listQuery,
      offset: undefined,
      limit: undefined,
      ids: selectList.value.map(item => item.id),
    }
    exportReview(data).then((res) => {
      exportFile(res.data, '分包方评审表')
      loading.close()
    })
      .catch((_) => {
        loading.close()
      })
  }
  else {
    ElMessage.warning('无可导出内容')
  }
}
// 取消
const canHandler = (row: any) => {
  ElMessageBox.confirm(
    '确认取消此申请吗?',
    '确认',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  ).then(() => {
    cancelReview({ id: row.id, processInstanceId: row.processId, comments: '' }).then((res) => {
      ElMessage.success('操作成功')
      search()
    })
  })
}
// 提交
const submit = (row: any) => {
  ElMessageBox.confirm(
    '确认提交吗？',
    '提示',
    {
      confirmButtonText: '确认',
      cancelButtonText: '取消',
      type: 'warning',
    },
  ).then((res) => {
    submitReview({ id: row.id, formId: SCHEDULE.SUBCONTRACT_REVIEW_APPROVAL }).then((res) => {
      ElMessage.success('已提交')
      search()
    })
  })
}
// 同意拒绝
const approvalDialogRef = ref()
const approveHandler = (row: any, type: string) => {
  approvalDialogRef.value.initDialog(type, row.taskId, row.processId, row.id)
}

// 审批状态发生变化
watch(() => $props.statusName, (newVal) => {
  if (newVal) {
    listQuery.approvalStatus = applyDict.value[newVal] as string
    fetchData()
  }
},
{
  deep: true,
  immediate: true,
})
const permUrl = ref({
  edit: '/tested/device/info/edit',
  del: '/tested/device/info/delete',
  submit: '/tested/device/info/submit',
  cancel: '/tested/device/info/cancel',
  agree: '/tested/device/info/agree',
  reject: '/tested/device/info/reject',
})
</script>

<template>
  <app-container>
    <!-- 审批弹窗 -->
    <approval-dialog ref="approvalDialogRef" @on-success="search" />
    <!-- 筛选条件 -->
    <search-area :need-clear="true" @search="search" @clear="reset">
      <search-item>
        <el-input v-model.trim="listQuery.reviewNo" placeholder="评审表编号" clearable />
      </search-item>
      <search-item>
        <el-input v-model.trim="listQuery.subcontractorCompanyName" placeholder="分包机构名称" clearable />
      </search-item>
      <search-item>
        <el-input v-model.trim="listQuery.createUserName" placeholder="申请人" clearable />
      </search-item>
      <search-item>
        <el-date-picker
          v-model="datetimerange" type="daterange" value-format="YYYY-MM-DD"
          format="YYYY-MM-DD" range-separator="至" start-placeholder="申请开始时间" end-placeholder="申请结束时间"
        />
      </search-item>
    </search-area>
    <table-container>
      <template v-if="$props.statusName === '全部'" #btns-right>
        <icon-button icon="icon-add" title="新增" @click="handler({}, 'create')" />
        <icon-button icon="icon-export" title="导出" @click="exportList" />
      </template>
      <!-- 普通表格 -->
      <normal-table
        :data="list" :total="total" :columns="columns" :query="listQuery" :list-loading="listLoading"
        :is-showmulti-select="true" :is-multi="true" @multi-select="multiSelect" @change="changePage"
      >
        <template #columns>
          <el-table-column v-if="$props.statusName !== '全部'" label="审批状况" align="center">
            <template #default=" scope ">
              {{ scope.row.approvalStatusName }}
            </template>
          </el-table-column>
          <el-table-column label="操作" width="160" align="center">
            <template #default=" scope ">
              <el-button link type="primary" size="small" @click="detail(scope.row)">
                查看
              </el-button>
              <el-button
                v-if="proxy.buttonPerm.edit.if({ approvalStatusName: $props.statusName }, permUrl.edit) && $props.statusName !== '全部'" link type="primary" size="small"
                @click="handler(scope.row, 'update')"
              >
                编辑
              </el-button>
              <el-button
                v-if="proxy.buttonPerm.agree.if({ approvalStatusName: $props.statusName }, permUrl.agree)" link type="primary" size="small"
                @click="approveHandler(scope.row, 'agree')"
              >
                同意
              </el-button>
              <el-button
                v-if="proxy.buttonPerm.reject.if({ approvalStatusName: $props.statusName }, permUrl.reject)" link type="primary" size="small"
                @click="approveHandler(scope.row, 'refuse')"
              >
                拒绝
              </el-button>
              <el-button
                v-if="proxy.buttonPerm.submit.if({ approvalStatusName: $props.statusName }, permUrl.submit)" link type="primary" size="small"
                @click="submit(scope.row)"
              >
                提交
              </el-button>
              <el-button
                v-if="proxy.buttonPerm.cancel.if({ approvalStatusName: $props.statusName }, permUrl.cancel)" link type="primary" size="small"
                @click="canHandler(scope.row)"
              >
                取消
              </el-button>
              <el-button
                v-if="proxy.buttonPerm.delete.if({ approvalStatusName: $props.statusName }, permUrl.del) && $props.statusName !== '全部'" link type="danger" size="small"
                @click="delHandler(scope.row)"
              >
                删除
              </el-button>
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </table-container>
  </app-container>
</template>

<style lang="scss" scoped>
.nortable-header {
  ::v-deep(.el-table__body-wrapper) {
    display: none;
  }
}
</style>

